#!/bin/bash
# woon 23-01-63

# For testing radtest command line purpose only.
clear
while true ;
do
  echo
  echo "To use radtest command by this script not keep password in .bash_history."
  echo "Running:  radtest username password localhost 0 secret"
  echo
  echo -n "Enter username: (without @domain) "
  read user
  if [ -z "${user}" ]; then
    echo
    echo "username is empty. re-enter again"
    continue
  fi
  echo -n "Enter password: "
  read -s pass
  if [ -z "${pass}" ]; then
    echo
    echo "password is empty. re-enter again"
    continue
  else
    break
  fi
done
freeradiusversion=$(freeradius -v | grep -i version | head -1 | awk '{print $4}' | cut -d. -f1,2)
case ${freeradiusversion} in
3.?)
  #3.x 
  echo 
  echo "radtest use secret from /etc/freeradius/3.0/client.conf"
  IPADDR=$(grep -v '#' /etc/freeradius/3.0/clients.conf | grep '^client\|=\|^}' | grep -A8 '^client localhost {' | grep ipaddr | head -1 | cut -d\= -f2 | awk '{print $1}')
  SECRET=$(grep -v '#' /etc/freeradius/3.0/clients.conf | grep '^client\|=\|^}' | grep -A8 '^client localhost {' | grep secret | head -1 | cut -d\= -f2 | awk '{print $1}')
  ;;
2.?)
  #2.x
  echo 
  echo "radtest use secret from /etc/freeradius/client.conf"
  IPADDR=$(grep -v '#' /etc/freeradius/clients.conf | grep '^client\|=\|^}' | grep -A8 '^client localhost {' | grep ipaddr | head -1 | cut -d\= -f2 | awk '{print $1}')
  SECRET=$(grep -v '#' /etc/freeradius/clients.conf | grep '^client\|=\|^}' | grep -A8 '^client localhost {' | grep secret | head -1 | cut -d\= -f2 | awk '{print $1}')
  ;;
*)
  #3.x up
  echo 
  echo "radtest use secret from /etc/freeradius/3.0/client.conf"
  IPADDR=$(grep -v '#' /etc/freeradius/3.0/clients.conf | grep '^client\|=\|^}' | grep -A8 '^client localhost {' | grep ipaddr | head -1 | cut -d\= -f2 | awk '{print $1}')
  SECRET=$(grep -v '#' /etc/freeradius/3.0/clients.conf | grep '^client\|=\|^}' | grep -A8 '^client localhost {' | grep secret | head -1 | cut -d\= -f2 | awk '{print $1}')
  ;;
esac
echo
echo 'Checking....'
echo
echo 'Remark:'
echo '  Access-Reject means username/password NOT valid.'
echo '  Access-Accept means username/password is valid (OK).'
echo
$(which radtest) "$user" "$pass" ${IPADDR} 0 ${SECRET} | grep 'rad_recv:\|Received' 2>&1
